---
{{ template "common.Service" (list . "nginx-ingress.Service") -}}

{{- define "nginx-ingress.Service" -}}
spec:
  type: LoadBalancer
  externalTrafficPolicy: Local
  {{- with .Values.service.ipFamilyPolicy }}
  ipFamilyPolicy: {{ . }}
  {{- end }}
  ports:
    - name: http
      protocol: TCP
      port: 80
      targetPort: http
    - name: https
      protocol: TCP
      port: 443
      targetPort: https
    - name: metrics
      protocol: TCP
      port: 10254
      targetPort: metrics
    {{- range $item := .Values.config.additionalPorts }}
    - name: proxy-{{ $item.protocol | lower }}-{{ $item.port }}
      protocol: {{ $item.protocol }}
      port: {{ $item.port }}
      targetPort: proxy-{{ $item.protocol | lower }}-{{ $item.port }}
    {{- end }}
{{- end }}

{{- if .Values.validatingWebhook.enabled }}
---
{{ template "common.Service" (list . "nginx-ingress.Service.webhook") -}}
{{- end }}

{{- define "nginx-ingress.Service.webhook" -}}
metadata:
  name: {{ template "common.fullname" . }}-webhook
spec:
  type: ClusterIP
  ports:
    - name: https
      protocol: TCP
      port: 443
      targetPort: webhook
{{- end }}
